"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bboxMapViewer = void 0;
var _react = _interopRequireWildcard(require("react"));
require("leaflet-arrowheads");
var _leaflet = _interopRequireDefault(require("leaflet"));
var _reactUuid = _interopRequireDefault(require("react-uuid"));
var _map = require("./map.constants");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var bboxMapViewer = function bboxMapViewer(args) {
  var documents = args.documents;
  var mapID = (0, _reactUuid["default"])();
  (0, _react.useEffect)(function () {
    map();
  }, []);
  var map = function map() {
    var map = _leaflet["default"].map("map-leaflet-id-".concat(mapID), {
      fullscreenControl: true,
      fullscreenControlOptions: {
        position: 'topleft'
      }
    });
    var tileLayer = _leaflet["default"].tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
      attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
    });
    tileLayer.addTo(map);

    // create an orange rectangle
    _leaflet["default"].rectangle(documents, {
      color: _map.LINE_COLOR,
      weight: 1
    }).addTo(map);

    // zoom the map to the rectangle bounds
    map.fitBounds(documents);
    window.map = map;
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    id: "map-leaflet-id-".concat(mapID),
    className: "rounded"
  });
};
exports.bboxMapViewer = bboxMapViewer;